const { filter, reject, map, shuffle, sortBy, fromPairs, groupBy } = require('../lib');

const arr1 = [
  { col1: 1, col2: 'b' },
  { col1: 2, col2: 'c' },
  { col1: 3, col2: 'd' },
  { col1: 4, col2: 'e' },
  { col1: 5, col2: 'a' },
];

const arr10 = [
  ['a', 3],
  ['b', 4],
  ['c', 6],
  [57, 'e'],
];

console.log(filter(arr1, item => item.col1 % 2 === 0));
console.log(reject(arr1, item => item.col1 % 2 === 0));
// console.log(filter(arr1, ['a', 'd']));
// console.log(reject(arr1, ['a', 'd']));
console.log(map(arr1, ({ col1, col2 }) => ({ col1: col1 * 2, col2 })));

console.log('');

const arr2 = shuffle(arr1);
console.log(arr2);
const arr3 = shuffle(arr1);
const arr4 = shuffle(arr2);
console.log(arr2);
console.log(arr3);
console.log(arr4);

console.log('');

console.log(sortBy(arr3, 'col1'));
console.log(sortBy(arr3, 'col1', true));
console.log(sortBy(arr3, 'col2'));
console.log(typeof (item => item.col1));
console.log(sortBy(arr4, item => (item.col2.codePointAt(0) - 96) * item.col1));

console.log('');
console.log(fromPairs(arr10));
console.log(fromPairs(map(arr10, ([x, y]) => [y, x])));

console.log('');
console.log(groupBy(arr1, 'col1'));
console.log(groupBy(arr1, x => x.col1 >= 2 && x.col1 <= 4 ? x.col1 : 0, x => x.col2));
