const { filter, reject, map, remap, toPairs } = require('../lib');

const obj1 = {
  a: 1,
  b: 2,
  c: 3,
  d: 4,
  e: 5,
};

console.log(filter(obj1, val => val % 2 === 0));
console.log(reject(obj1, val => val % 2 === 0));
console.log(filter(obj1, ['a', 'd']));
console.log(reject(obj1, ['a', 'd']));
console.log(map(obj1, val => val * 2));
console.log(remap(obj1, ([key, val]) => [key + 1, val * 2]));

console.log('');
console.log(toPairs(obj1));
